package rocks.zipcode.atm;

import javafx.geometry.Pos;
import javafx.scene.control.*;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.image.ImageViewBuilder;
import javafx.scene.layout.HBox;
import javafx.scene.text.TextAlignment;
import javafx.scene.text.TextFlow;
import javafx.stage.StageStyle;
import rocks.zipcode.atm.bank.Bank;
import javafx.application.Application;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import javafx.scene.layout.FlowPane;


import javax.swing.*;
import javax.swing.text.html.ImageView;
import javax.xml.soap.Text;
import java.awt.*;
import java.awt.Image;
import java.io.FileInputStream;
import java.util.HashMap;

/**
 * @author ZipCodeWilmington
 */
public class CashMachineApp extends Application {

    private TextField field = new TextField();
    private TextField field2 = new TextField();
    private CashMachine cashMachine = new CashMachine(new Bank());
    private ComboBox accountNumbers = new ComboBox(cashMachine.getIdList());

    private Parent createContent() {
        VBox vbox = new VBox(10);
        vbox.setPrefSize(600, 820);
        vbox.setStyle("-fx-background-color: lightslategray; -fx-padding: 20; -fx-font-size: 20;");

        Label header = new Label("Welcome to ZipCloud Bank");
        header.setStyle("-fx-text-fill: turquoise; -fx-font-size: 42; -fx-font-family: Charter; -fx-border-radius: 10; -fx-label-padding: 8; -fx-border-width: 4; -fx-border-color: greenyellow;");



        TextField areaAccountId = new TextField();
        areaAccountId.setStyle("-fx-background-color: lightsteelblue;");
        areaAccountId.setManaged(false);
        areaAccountId.setEditable(false);

        Label accountId = new Label("Account ID:");
        accountId.setManaged(false);
        accountId.setStyle("-fx-text-fill: white;");

       // HBox accountIdInfo = new HBox(5);
        //accountIdInfo.getChildren().addAll(accountId, areaAccountId);

        TextField areaAccountName = new TextField();
        areaAccountName.setManaged(false);
        areaAccountName.setStyle("-fx-background-color: lightsteelblue;");
        areaAccountName.setEditable(false);

        Label accountName = new Label("Account Holder:");
        accountName.setStyle("-fx-text-fill: white;");
        accountName.setManaged(false);

        //HBox nameInfo = new HBox(5);
        //nameInfo.getChildren().addAll(accountName, areaAccountName);

        TextField areaAccountEmail = new TextField();
        areaAccountEmail.setManaged(false);
        areaAccountEmail.setStyle("-fx-background-color: lightsteelblue;");
        areaAccountEmail.setEditable(false);

        Label accountEmail = new Label("Email:");
        accountEmail.setStyle("-fx-text-fill: white;");
        accountEmail.setManaged(false);

        //HBox accountEmailInfo = new HBox(5);
        //accountEmailInfo.getChildren().addAll(accountEmail, areaAccountEmail);

        TextField areaAccountAmount = new TextField();
        areaAccountAmount.setManaged(false);
        areaAccountAmount.setStyle("-fx-background-color: mediumturquoise;");
        areaAccountAmount.setEditable(false);

        Label accountBalance = new Label("Balance:");
        accountBalance.setStyle("-fx-text-fill: greenyellow;");
        accountBalance.setManaged(false);

        /*
        HBox accountBalanceInfo = new HBox(5);
        accountBalanceInfo.getChildren().addAll(accountBalance, areaAccountAmount);

        accountIdInfo.setPrefSize(100, 100);
        accountIdInfo.setStyle("-fx-background-color: mediumaquamarine; -fx-padding: 20; -fx-font-size: 20;");
        */

        field2.setManaged(false);

        Label fieldLabel2 = new Label("Amount:");
        fieldLabel2.setManaged(false);
        fieldLabel2.setStyle("-fx-text-fill: greenyellow;");
        Label fieldLabel = new Label("Select Your Account Number:");
        fieldLabel.setStyle("-fx-text-fill: greenyellow;");

        field.setStyle("-fx-background-color: lightgrey;");
        field2.setStyle("-fx-background-color: lightgrey;");
        Label passwordLabel = new Label("Password:");
        passwordLabel.setStyle("-fx-text-fill: greenyellow;");


        //Make Button Do something.
        Button btnNewAccount = new Button("Setup New Account");
        btnNewAccount.setDisable(true);
       /*
        btnSubmit.setOnAction(e -> {

        });
*/

        Button btnDeposit = new Button("Deposit");
        btnDeposit.setManaged(false);
        btnDeposit.setOnAction(e -> {
            float amount = Float.parseFloat(field2.getText());
            cashMachine.deposit(amount);

            areaAccountAmount.setText(Float.toString(cashMachine.getBalance()));
        });


        Button btnWithdraw = new Button("Withdraw");
        btnWithdraw.setManaged(false);
        btnWithdraw.setOnAction(e -> {
            float amount = Float.parseFloat(field2.getText());
            cashMachine.withdraw(amount);
            areaAccountAmount.setText(Float.toString(cashMachine.getBalance()));
        });

        Button btnResetPassword = new Button("Reset Password");
        btnResetPassword.setManaged(false);
        btnResetPassword.setOnAction(e -> {
            int id = Integer.parseInt(accountNumbers.getValue().toString());
            String password = field.getText();
            cashMachine.resetPassword(id, password);
            passwordLabel.setText(cashMachine.message("Password Reset."));
        });

        Button btnExit = new Button("Log Out");
        btnExit.setManaged(false);
        btnExit.setOnAction(e -> {
            cashMachine.exit();
            field.clear();
            field2.clear();
            areaAccountAmount.clear();
            areaAccountEmail.clear();
            areaAccountId.clear();
            areaAccountName.clear();
            passwordLabel.setText("Password:");


            field2.setVisible(false);
            fieldLabel2.setVisible(false);
            btnDeposit.setVisible(false);
            btnWithdraw.setVisible(false);
            btnExit.setVisible(false);
            btnResetPassword.setVisible(false);

            areaAccountAmount.setVisible(false);
            areaAccountEmail.setVisible(false);
            areaAccountId.setVisible(false);
            areaAccountName.setVisible(false);

            accountBalance.setVisible(false);
            accountEmail.setVisible(false);
            accountId.setVisible(false);
            accountName.setVisible(false);
        });

        Button btnSubmit = new Button("Enter");
        btnSubmit.setOnAction(e -> {
            int id = Integer.parseInt(accountNumbers.getValue().toString());
            String passwordInput = field.getText();
            if(cashMachine.checkPassword(id, passwordInput)) {
                cashMachine.login(id);
                areaAccountAmount.setText(Float.toString(cashMachine.getBalance()));
                areaAccountEmail.setText(cashMachine.getEmail());
                areaAccountId.setText(Integer.toString(cashMachine.getId()));
                areaAccountName.setText(cashMachine.getName());
                areaAccountAmount.setManaged(true);
                areaAccountEmail.setManaged(true);
                areaAccountId.setManaged(true);
                areaAccountName.setManaged(true);
                accountId.setManaged(true);
                accountName.setManaged(true);
                accountEmail.setManaged(true);
                accountBalance.setManaged(true);
                passwordLabel.setText("New Password:");
                btnDeposit.setManaged(true);
                btnWithdraw.setManaged(true);
                btnExit.setManaged(true);
                btnResetPassword.setManaged(true);
                accountId.setManaged(true);
                field2.setManaged(true);
                fieldLabel2.setManaged(true);

                field2.setVisible(true);
                fieldLabel2.setVisible(true);
                btnDeposit.setVisible(true);
                btnWithdraw.setVisible(true);
                btnExit.setVisible(true);
                btnResetPassword.setVisible(true);

                areaAccountAmount.setVisible(true);
                areaAccountEmail.setVisible(true);
                areaAccountId.setVisible(true);
                areaAccountName.setVisible(true);

                accountBalance.setVisible(true);
                accountEmail.setVisible(true);
                accountId.setVisible(true);
                accountName.setVisible(true);

            } else {
                passwordLabel.setText(cashMachine.message("Incorrect Password.  Try Again."));
            }
        });



        /*
        String path = "https://drive.google.com/file/d/1PR_cLhzJ9IFcnWF46QSX_WEcnFT-uI0Q/view?usp=sharing";

        Image image = new Image(path);
*/

        FlowPane flowpane = new FlowPane();

        flowpane.getChildren().add(btnSubmit);
        flowpane.getChildren().add(btnResetPassword);
        flowpane.getChildren().add(btnNewAccount);

        FlowPane flowpane2 = new FlowPane();

        flowpane2.getChildren().add(btnDeposit);
        flowpane2.getChildren().add(btnWithdraw);
        flowpane2.getChildren().add(btnExit);

        vbox.getChildren().addAll(header, fieldLabel, accountNumbers, passwordLabel, field, flowpane, fieldLabel2, field2, flowpane2, accountId, areaAccountId, accountName, areaAccountName, accountEmail, areaAccountEmail, accountBalance, areaAccountAmount);



        return vbox;


    }

    @Override
    public void start(Stage primarystage) throws Exception {
        primarystage.setTitle("ZipCloud Bank");
        primarystage.setScene(new Scene(createContent()));
        primarystage.show();

    }

    public static void main(String[] args) {

        launch(args);

    }


}
