package rocks.zipcode.atm.bank;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import rocks.zipcode.atm.ActionResult;

import java.awt.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 * @author ZipCodeWilmington
 */
public class Bank {

    private Map<Integer, Account> accounts = new HashMap<>();
    private Map<Integer, String> passwords = new HashMap<>();
    //private static int nextId = 1000;

    /* Add options for user to create an account and have a number issued to them. */

    public Bank() {
        accounts.put(1000, new BasicAccount(new AccountData(
                1000, "Nick Foles", "LIImvp@gmail.com", 500
        )));

        passwords.put(1000, "password");

        accounts.put(1100, new BasicAccount(new AccountData(
                1100, "Dan Green", "dgreen@gmail.com", 100000
        )));

        passwords.put(1100, "password");

        accounts.put(1200, new BasicAccount(new AccountData(
                1200, "Billy Madison", "back2school@gmail.com", 500
        )));

        passwords.put(1200, "password");

        accounts.put(1300, new BasicAccount(new AccountData(
                1300, "Chase Utley", "grandpa@gmail.com", 2008
        )));

        passwords.put(1300, "password");

        accounts.put(1400, new PremiumAccount(new AccountData(
                1400, "Elle Woods", "pink@gmail.com", 20
        )));

        passwords.put(1400, "password");

        accounts.put(1500, new PremiumAccount(new AccountData(
                1500, "Harry Potter", "seeker4life@wizmail.com", 200
        )));

        passwords.put(1500, "password");

        accounts.put(1600, new BasicAccount(new AccountData(
                1600, "Hermione Granger", "librarylover@gmail.com", 950
        )));

        passwords.put(1600, "password");

        accounts.put(1700, new BasicAccount(new AccountData(
                1700, "Hayden Stewart", "hstew@gmail.com", 100
        )));

        passwords.put(1700, "password");

        accounts.put(1800, new BasicAccount(new AccountData(
                1800, "Jack Traven", "speed@gmail.com", 50
        )));

        passwords.put(1800, "password");

        accounts.put(1900, new BasicAccount(new AccountData(
                1900, "Jimmy Fallon", "jimmy@nbc.com", 1000
        )));

        passwords.put(1900, "password");

        accounts.put(2000, new PremiumAccount(new AccountData(
                2000, "Frankie Smith", "frank@gmail.com", 2040
        )));

        passwords.put(2000, "password");

        accounts.put(2100, new PremiumAccount(new AccountData(
                2100, "Ron Weasley", "ron@wizmail.com", 2003
        )));

        passwords.put(2100, "password");
    }

/*How to use this???
    public Bank(String name, String email, int initialBalance, boolean typeOfAccount) {
        nextId++;
        if (!typeOfAccount) {
        accounts.put(nextId, new BasicAccount(new AccountData(
                nextId, name, email, initialBalance
        ))); } else {
            accounts.put(nextId, new PremiumAccount(new AccountData(
                    nextId, name, email, initialBalance
            )));
        }

    }

*/

    public String getPassword(int accountNumber) {
        return passwords.get(accountNumber);
    }

    public void resetPassword(int accountNumber, String newPassword) {
        passwords.put(accountNumber, newPassword);
    }

    public ObservableList<Integer> getIdList() {

        ObservableList<Integer> idList = FXCollections.observableArrayList();

        for (Integer key: accounts.keySet()) {

            idList.add(key);
        }
            return idList;
    }

    public ActionResult<AccountData> getAccountById(int id) {
        Account account = accounts.get(id);

        if (account != null) {
            return ActionResult.success(account.getAccountData());
        } else {
            return ActionResult.fail("No account with id: " + id);
        }
    }

    public ActionResult<AccountData> deposit(AccountData accountData, float amount) {
        Account account = accounts.get(accountData.getId());
        account.deposit(amount);

        return ActionResult.success(account.getAccountData());
    }

    public ActionResult<AccountData> withdraw(AccountData accountData, float amount) {
        Account account = accounts.get(accountData.getId());
        boolean ok = account.withdraw(amount);
        if (ok) {
            return ActionResult.success(account.getAccountData());
        } else {
            return ActionResult.fail("Withdraw failed: " + amount + ". Account has: " + account.getBalance());
        }
    }


}
